import { InjectionToken, Type } from 'injection-js';
import { ServiceInterface } from '@rxstack/platform';
import { QueryInterface } from '@rxstack/query-filter';
export declare type AlterMethod = 'pick' | 'omit';
export interface SoftDeleteOptions {
    deleteField?: string;
}
export interface PopulateSchema<T> {
    service: Type<ServiceInterface<T>> | InjectionToken<ServiceInterface<T>>;
    parentField: string;
    childField: string;
    method?: string;
    nameAs?: string;
    query?: QueryInterface;
}
export interface CurrentUserOptions {
    idField?: string;
    targetField?: string;
}
export interface ValidateUniqueOptions {
    service: Type<ServiceInterface<any>> | InjectionToken<ServiceInterface<any>>;
    properties: string[];
    propertyPath: string;
    method?: string;
    message?: string;
}
