"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const platform_1 = require("@rxstack/platform");
const exceptions_1 = require("@rxstack/exceptions");
const _ = require("lodash");
const utils_1 = require("./utils");
exports.queryWithCurrentUser = (options) => {
    return (event) => __awaiter(this, void 0, void 0, function* () {
        utils_1.restrictToOperations(event.eventType, [platform_1.OperationEventsEnum.PRE_EXECUTE]);
        options = _.merge({ idField: 'id', targetField: 'userId' }, options);
        const token = event.request.token;
        utils_1.assertToken(token);
        let userProp = utils_1.getProperty(token.getUser(), options.idField);
        const criteria = { [options.targetField]: { '$eq': userProp } };
        if (event.request.attributes.has('query')) {
            _.merge(event.request.attributes.get('query'), { where: criteria });
        }
        else if (event.request.attributes.has('criteria')) {
            _.merge(event.request.attributes.get('criteria'), criteria);
        }
        else {
            throw new exceptions_1.BadRequestException('Query or Criteria is not set');
        }
    });
};
//# sourceMappingURL=query-with-current-user.js.map