"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const exceptions_1 = require("@rxstack/exceptions");
const utils_1 = require("./utils");
exports.rename = (key, newKey, propertyPath) => {
    return (event) => __awaiter(this, void 0, void 0, function* () {
        utils_1.mapToEventData(event, exports.doRename, [key, newKey, propertyPath]);
    });
};
exports.doRename = (source, key, newKey, propertyPath) => {
    const data = propertyPath ? _.get(source, propertyPath) : source;
    if (!data) {
        throw new exceptions_1.BadRequestException('doRename: source is not valid');
    }
    const result = _.isArray(data) ? data.map((value) => doRenameItem(value, key, newKey)) :
        doRenameItem(data, key, newKey);
    return propertyPath ? _.set(source, propertyPath, result) : result;
};
const doRenameItem = (data, key, newKey) => {
    const value = _.get(data, key);
    if (!value) {
        throw new exceptions_1.BadRequestException(`Object with key ${key} does not exist.`);
    }
    _.set(data, newKey, _.clone(value));
    _.unset(data, key);
    return data;
};
//# sourceMappingURL=rename.js.map