"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const exceptions_1 = require("@rxstack/exceptions");
const _ = require("lodash");
exports.doAlter = (source, methodName, fieldNames, propertyPath) => {
    const method = methodName === 'pick' ? _.pick : _.omit;
    const data = propertyPath ? _.get(source, propertyPath) : source;
    if (!data) {
        throw new exceptions_1.BadRequestException('Source in doAlter is not valid.');
    }
    const result = _.isArray(data) ? data.map((value) => method(value, fieldNames)) :
        method(data, fieldNames);
    return propertyPath ? _.set(source, propertyPath, result) : result;
};
//# sourceMappingURL=do-alter.js.map